## Class javaview

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - java.awt.Panel
      - - java.applet.Applet
        - - javaview

- All Implemented Interfaces:
    java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, java.lang.Runnable, javax.accessibility.Accessible

      public class javaview
      extends java.applet.Applet
      implements java.lang.Runnable

  Applet runs javaview with possibility to load one or more geometry models for display. Many projects are pre-installed and may be invoked via menu FILE->NEW PROJECT, applet parameters, and command line arguments.

  If Mathematica graphics is piped through stdin then javaview converts the input stream to a geometry object and displays it.

  JavaView may be started using pre-configured camera and display settings read from a file.

  See Also:
    `PvViewer`, Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.BaselineResizeBehavior`

  - ### Field Summary

    - ### Fields inherited from class java.awt.Component

      `BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `javaview()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addPickListener(PvPickListenerIf listener)` Add pick listener to receive pick events `PvPickEvent` to the default display.
    `void` | `destroy()` Does clean-up when applet is destroyed by the browser.
    `void` | `finalize()`
    `java.lang.String` | `getAppletInfo()` Interface of applet to inform about author, version, and copyright
    `java.awt.Dimension` | `getPreferredSize()` We need a preferred size such that the frame is able to estimate how many rows the menu bar will occupy.
    `PvViewer` | `getViewer()` Method added to have better access in J/Link.
    `void` | `init()` Initializes the applet and creates a thread that configures and initializes the viewer, loads system and user projects.
    `void` | `loadModel(java.lang.String fileName)` Load a model from one or more geometry files through JavaScript into a running JavaView applet.
    `static void` | `main(java.lang.String[] args)` Standalone application support.
    `void` | `paint(java.awt.Graphics g)` Print info while initializing applet and viewer, and draw background image.
    `boolean` | `removePickListener(PvPickListenerIf listener)` Remove a registered listener from list of registered listeners.
    `void` | `run()` Configure and initialize the viewer, load system and user projects.
    `void` | `startFromThread()` Start viewer, e.g. start animation if requested.
    `void` | `stop()` Stop viewer, e.g. stop animation if requested

    - ### Methods inherited from class java.applet.Applet

      `getAccessibleContext, getAppletContext, getAudioClip, getAudioClip, getCodeBase, getDocumentBase, getImage, getImage, getLocale, getParameter, getParameterInfo, isActive, isValidateRoot, newAudioClip, play, play, resize, resize, setStub, showStatus, start`

    - ### Methods inherited from class java.awt.Panel

      `addNotify`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getAlignmentX, getAlignmentY, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getInsets, getLayout, getListeners, getMaximumSize, getMinimumSize, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, print, printComponents, remove, remove, removeAll, removeContainerListener, removeNotify, setComponentZOrder, setFocusCycleRoot, setFocusTraversalKeys, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setFont, setLayout, transferFocusDownCycle, update, validate`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, disable, dispatchEvent, enable, enable, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphics, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocation, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getToolkit, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isOpaque, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, printAll, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, repaint, requestFocus, requestFocusInWindow, reshape, revalidate, setBackground, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeysEnabled, setForeground, setIgnoreRepaint, setLocale, setLocation, setLocation, setMaximumSize, setMinimumSize, setName, setPreferredSize, setSize, setSize, setVisible, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### javaview

          public javaview()

  - ### Method Detail

    - #### getViewer

          public PvViewer getViewer()

      Method added to have better access in J/Link.

    - #### getAppletInfo

          public java.lang.String getAppletInfo()

      Interface of applet to inform about author, version, and copyright
      Overrides:
        `getAppletInfo` in class `java.applet.Applet`

    - #### init

          public void init()

      Initializes the applet and creates a thread that configures and initializes the viewer, loads system and user projects.
      Overrides:
        `init` in class `java.applet.Applet`

    - #### run

          public void run()

      Configure and initialize the viewer, load system and user projects. If a geometry model is given as applet parameter or command line argument then geometry is loaded. Depending on other parameters a panel for browsing geometry files may be shown close to the display.

      This method may not be called before applet.init().

      Specified by:
        `run` in interface `java.lang.Runnable`

    - #### main

          public static void main(java.lang.String[] args)

      Standalone application support. The main() method acts as the applet's entry point when it is run as a standalone application. It is ignored if the applet is run from within an HTML page.

    - #### loadModel

          public void loadModel(java.lang.String fileName)

      Load a model from one or more geometry files through JavaScript into a running JavaView applet. All existing geometries in the display will be removed.

      Model argument may contain multiple filenames separated by ';'. All file names must by given relative to the model codebase.

      Method is intended for use from JavaScript. Therefore, the current codebase will be prepended to the given relative filename.

      Parameters:
        `fileName` - relative fileName.
      Since:
        JavaView v3.89.005

    - #### getPreferredSize

          public java.awt.Dimension getPreferredSize()

      We need a preferred size such that the frame is able to estimate how many rows the menu bar will occupy.
      Overrides:
        `getPreferredSize` in class `java.awt.Container`

    - #### paint

          public void paint(java.awt.Graphics g)

      Print info while initializing applet and viewer, and draw background image.
      Overrides:
        `paint` in class `java.awt.Container`

    - #### addPickListener

          public void addPickListener(PvPickListenerIf listener)

      Add pick listener to receive pick events `PvPickEvent` to the default display.
      Parameters:
        `listener` - will receive pick events of this applet.
      See Also:
        `removePickListener(PvPickListenerIf)`

    - #### removePickListener

          public boolean removePickListener(PvPickListenerIf listener)

      Remove a registered listener from list of registered listeners.
      Parameters:
        `listener` - previously registered listener.
      Returns:
        `false` if listener does not exists.
      See Also:
        `addPickListener(PvPickListenerIf)`

    - #### destroy

          public void destroy()

      Does clean-up when applet is destroyed by the browser. Here we just close and dispose all our control windows.
      Overrides:
        `destroy` in class `java.applet.Applet`

    - #### stop

          public void stop()

      Stop viewer, e.g. stop animation if requested
      Overrides:
        `stop` in class `java.applet.Applet`

    - #### finalize

          public void finalize()
                        throws java.lang.Throwable

      Overrides:
        `finalize` in class `java.lang.Object`
      Throws:
        `java.lang.Throwable`

    - #### startFromThread

          public void startFromThread()

      Start viewer, e.g. start animation if requested. Necessary, if initialization is done in a separate thread. In this case the original applet.start() has no effect.

"

The software JavaView? is copyright protected. All Rights Reserved.
"